//____CULEBRA___________________________________
//Juego Snake realizado por kaltorak para el manual Snake en SDL/C++
//Modificado por SETA43

#include <unistd.h>
#include <string.h>
#include <stdio.h>

#include <stdlib.h>

#include <time.h>
#include <SDL/SDL.h>
#include "SDL/SDL_ttf.h"
#include "SDL/SDL_image.h"
#include "SDL/SDL_mixer.h"

#include <cstdlib>
#include <vector>
#include <time.h>

#include "main.h"
#include "xgrafi.h"

using namespace std;

int Colision(SDL_Rect,SDL_Rect);
void Iniciar(void);
#define Arriba 1
#define Derecha 2
#define Abajo 3
#define Izquierda 4
const int ResolucionX = SCREEN_WIDTH;
const int ResolucionY = SCREEN_HEIGHT;
const int PColor = SCREEN_BPP;

int LongitudSerpiente = 0;
int Direccion = 0;
int Control = 0;
SDL_Rect Ultimo;
int Puntos = 0;

char Titulo[255];

struct Cuadro
{
    SDL_Rect Posicion;
    Cuadro() {
        Posicion.x = 0;
        Posicion.y = 0;
        Posicion.w = 20;
        Posicion.h = 20;
    }
} Manzana;
vector <Cuadro> Serpiente;




void imprixxx(int xi, int yi, int xo, int yo, int w, int h)
{
    static SDL_Rect clip[ 1 ];
    clip[ 0 ].x = xi;
    clip[ 0 ].y = yi;
    clip[ 0 ].w = w;
    clip[ 0 ].h = h;
    apply_surfaceB( xo, yo, dots, screen, &clip[ 0 ] );
}


int cabezaX,cabezaY;

void Repaint(void);
void animarMuerte(void);
void animarInicio(void);
void printPanta(void);


int inkeyM(void);
int waitQuit(void);
void printc(int x, int y, char* temp);
void printn(int x, int y, long temp);
void impri(int x, int y, char c);
char *inputc(int x, int y);
void cls(int r,int g,int b);

int retardo;
int tiempo;   

#include "puntos.h"


Mix_Chunk *acomer4 = NULL;
Mix_Chunk *aempezar = NULL;
Mix_Chunk *amuerte = NULL;

//====================JUEGO=======================




int main (int argc, char *argv[])
{

    int quit = 0;
    int SimbolKey;
	bool fullScreen = false;

    if (init(SCREEN_WIDTH,SCREEN_HEIGHT) == 0 ) return 1;
    if ( SDL_Flip( screen ) == -1 ) return 3;
    //Fondo,graficos,fuentes
    if (load_files(NULL, (char*)"modelo1.png", (char*)"setam.ttf") == 0 ) return 2;

    aempezar = Mix_LoadWAV( "aempezar.wav" );
    acomer4=  Mix_LoadWAV( "acomer4.wav" );
    amuerte = Mix_LoadWAV( "amuerte.wav" );
    
    if(Mix_OpenAudio(22050, MIX_DEFAULT_FORMAT, MIX_DEFAULT_CHANNELS, 1024) == -1) //Initialisation de l'API Mixer
       {  printf("%s", Mix_GetError());   }
    else
        {  printf("OK MIX\n");   }
    Mix_Music *musique; 
    musique = Mix_LoadMUS("acule.ogg");  
    
    SDL_ShowCursor(SDL_DISABLE);

    load_puntos();
    puntuar(0);
  
	
Inicio:
    retardo=150;
    tiempo=0;
    Iniciar();
    animarInicio();
    Mix_PlayMusic(musique, -1);
    Mix_RewindMusic();
    printPanta();
    imprixxx(60,0,Serpiente[0].Posicion.x, Serpiente[0].Posicion.y, 20, 20);
    SDL_Flip(screen);
    
    SDL_Delay(1000);
    Mix_PlayChannel( -1, acomer4, 0 );

    Direccion = Arriba;
    //__________JUEGO___________________________

    while ( quit == 0 )
    {
        SDL_Delay(retardo-(tiempo/10));
        tiempo++;
        
        while ( SDL_PollEvent( &event ) )
        {
            switch (event.type)
            {
            case  SDL_KEYUP:
                SimbolKey = event.key.keysym.sym;
                break;
            case  SDL_KEYDOWN:
                SimbolKey = event.key.keysym.sym;
                switch (SimbolKey)
                {
				 case  SDLK_F1:
					fullScreen = !fullScreen;
					if(fullScreen)
					{
#if YesWindows
                    screen = SDL_SetVideoMode( SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP, SDL_FULLSCREEN | SDL_SWSURFACE );
#else
                    SDL_WM_ToggleFullScreen(screen);
#endif
					}
					else
					{
					 screen = SDL_SetVideoMode( SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP, SDL_SWSURFACE );
					}
                    Repaint();
                    break;
                case  SDLK_ESCAPE:
                    quit = 1;
                    break;
                case SDLK_UP :
                    if(Direccion!= Abajo)Direccion = Arriba;
                    break;
                case SDLK_DOWN :
                    if(Direccion!= Arriba)Direccion = Abajo;
                    break;
                case SDLK_LEFT :
                    if(Direccion!= Derecha)Direccion = Izquierda;
                    break;
                case SDLK_RIGHT :
                    if(Direccion!= Izquierda)Direccion = Derecha;
                    break;
                }

                break;
            case  SDL_QUIT:
                quit = 1;
                break;
            }
        }


        if(Direccion != 0)
        {
            //Almacenamos la posicion del ultimo de los elementos que forman la cola en la variable Ultimo.
            Ultimo.x = Serpiente[LongitudSerpiente].Posicion.x;
            Ultimo.y = Serpiente[LongitudSerpiente].Posicion.y;

            //Movemos la cola de la serpiente.
            for(int I = LongitudSerpiente; I >= 1; I--)
            {
                Serpiente[I].Posicion.x = Serpiente[I-1].Posicion.x;
                Serpiente[I].Posicion.y = Serpiente[I-1].Posicion.y;
            }
        }

        cabezaX=Serpiente[0].Posicion.x;
        cabezaY=Serpiente[0].Posicion.y;

        switch (Direccion)
             {
                case  Arriba:
                    Serpiente[0].Posicion.y -= Serpiente[0].Posicion.h;
                break;
                case  Abajo:
                    Serpiente[0].Posicion.y += Serpiente[0].Posicion.h;
                break;
                case  Derecha:
                    Serpiente[0].Posicion.x += Serpiente[0].Posicion.w;
                break;
                case  Izquierda:
                    Serpiente[0].Posicion.x -= Serpiente[0].Posicion.w;
                break;
                 
             }
        //Comprobamos la colision de la serpiente con el borde.
        if(((Serpiente[0].Posicion.x + Serpiente[0].Posicion.w)  > ResolucionX)
                || (Serpiente[0].Posicion.x < 0)
                || ((Serpiente[0].Posicion.y + Serpiente[0].Posicion.h)  > ResolucionY)
                || (Serpiente[0].Posicion.y < 0))
            {
                Mix_PauseMusic();
                animarMuerte();
                puntuar(Puntos);
                if(1==waitQuit()) break;    //Salir
                goto Inicio; 
            }

        //Comprobamos la colision de la serpiente con la cola.
        for(int I = 1; I <= LongitudSerpiente; I++)
        {
            if(Colision(Serpiente[0].Posicion,Serpiente[I].Posicion))
            {
                Mix_PauseMusic();
                animarMuerte();
                puntuar(Puntos);
                if(1==waitQuit()) break;  //Salir
                goto Inicio;
            }
        }

        //Comprobamos la colision de la serpiente con la Manzana.
        if(Colision(Serpiente[0].Posicion,Manzana.Posicion))
        {
            LongitudSerpiente++;
            Puntos += 10;
            Mix_PlayChannel( -1, acomer4, 0 );
            Serpiente.push_back(Cuadro());
            Serpiente[LongitudSerpiente].Posicion.x = Ultimo.x;
            Serpiente[LongitudSerpiente].Posicion.y = Ultimo.y;

            do
            {
                Manzana.Posicion.x = ((rand() % ((ResolucionX-Manzana.Posicion.w)/Manzana.Posicion.w))*Manzana.Posicion.w);
                Manzana.Posicion.y = ((rand() % ((ResolucionY-Manzana.Posicion.h)/Manzana.Posicion.h))*Manzana.Posicion.h);
                Control = 0;
                for(int I = 1; I <= LongitudSerpiente; I++)
                {
                    if(Colision(Manzana.Posicion,Serpiente[I].Posicion))
                    {
                        Control = 1;
                        I = LongitudSerpiente;
                    }
                }
            }
            while(Control == 1);
        }

        printPanta();
    }

//Cerrar todo el SDL
    clean_up();
    Mix_FreeMusic(musique); 

    printf("Fin __CULEBRA 2023_ xsetaseta@gmail.com\n");
    SDL_Delay(400);
    return 0;
}


//____________________FIN____________

void Repaint(void)
{
    printPanta();
}

//_________________________________________________________________

void printPanta(void)
{
    SDL_FillRect(screen, 0, SDL_MapRGB(screen->format, 0, 0, 0));
    for(int I = 0; I <= LongitudSerpiente; I++)
    {
        if(I==0)
        {
            switch (Direccion)
            {
            case  Arriba:
                if(I==0) imprixxx(60,0,Serpiente[I].Posicion.x, Serpiente[I].Posicion.y, 20, 20);
                break;
            case  Derecha:
                if(I==0) imprixxx(80,0,Serpiente[I].Posicion.x, Serpiente[I].Posicion.y, 20, 20);
                break;
            case  Abajo:
                if(I==0) imprixxx(100,0,Serpiente[I].Posicion.x, Serpiente[I].Posicion.y, 20, 20);
                break;
            case  Izquierda:
                if(I==0) imprixxx(120,0,Serpiente[I].Posicion.x, Serpiente[I].Posicion.y, 20, 20);
                break;
            }
        }
        else
        {
            if(I==LongitudSerpiente)
            {
                imprixxx(40,0,Serpiente[I].Posicion.x, Serpiente[I].Posicion.y, 20, 20);
            }
            else
            {
                imprixxx(20,0,Serpiente[I].Posicion.x, Serpiente[I].Posicion.y, 20, 20);
            }
        }
    }

    imprixxx(0,0, Manzana.Posicion.x, Manzana.Posicion.y, 20, 20);
    printPuntos();
    SDL_Flip(screen);
}


//_________________________________________________________________

void animarMuerte(void)
{
    int z;

    Mix_PlayChannel( -1, amuerte, 0 );
    for(z=1; z<20; z++)
    {
        imprixxx(140,0,cabezaX,cabezaY, 20, 20);
        for(int I = 0; I <= LongitudSerpiente; I++)
        {
            imprixxx(140,0,Serpiente[I].Posicion.x, Serpiente[I].Posicion.y, 20, 20);
        }
        SDL_Flip( screen );
        SDL_Delay(100);
        imprixxx(160,0,cabezaX,cabezaY, 20, 20);
        for(int I = 0; I <= LongitudSerpiente; I++)
        {
            imprixxx(160,0,Serpiente[I].Posicion.x, Serpiente[I].Posicion.y, 20, 20);
        }
        SDL_Flip( screen );
        SDL_Delay(100);
    }
    SDL_Delay(600);
}


void animarInicio(void)
{
    int x;
    
    cls(0,0,0);
    imprixxx(0,0, 320, 220, 20, 20);

    Mix_PlayChannel( -1,aempezar, 0 );

    for(x=0;x<660;x+=20)
      {
        imprixxx(20,0, x-20,220, 20, 20);
        imprixxx(80,0, x,220, 20, 20);
        SDL_Flip( screen );
        SDL_Delay(80);
      }
    for(x=0;x<640;x+=20)
      {
        imprixxx(0,20, x-20,220, 20, 20);
        imprixxx(40,0, x,220, 20, 20);
        SDL_Flip( screen );
        SDL_Delay(80);
      }
    cls(0,0,0);
    
}




//Funcion que compruba las colisiones entre los elementos de juego.
int Colision(SDL_Rect H,SDL_Rect M)
{
    if (((H.x + H.w) > M.x) && ((H.y + H.h) > M.y) &&
            ((M.x + M.w) > H.x) && ((M.y + M.h) > H.y))
    {
        return 1;
    }
    else
    {
        return 0;
    }
}



//Funcion que reinicia el juego cuando la serpiente colisiona con ella misma o el borde.
void Iniciar(void)
{
    LongitudSerpiente = 0;
    Direccion = 0;
    Puntos = 0;
    Serpiente.clear();
    Serpiente.push_back(Cuadro());
    Manzana.Posicion.x = ((rand() % ((ResolucionX-Manzana.Posicion.w)/Manzana.Posicion.w))*Manzana.Posicion.w);
    Manzana.Posicion.y = ((rand() % ((ResolucionY-Manzana.Posicion.h)/Manzana.Posicion.h))*Manzana.Posicion.h);
    Serpiente[0].Posicion.x = (((ResolucionX/Serpiente[0].Posicion.w)/2)*Serpiente[0].Posicion.w);
    Serpiente[0].Posicion.y = (((ResolucionY/Serpiente[0].Posicion.h)/2)*Serpiente[0].Posicion.h);
}


//___________Rutinas basicas___________________
int inkeyM()
{
    int tecla;
    SDL_Delay(200);
    while ( SDL_PollEvent( &event ) )
    {
        switch (event.type)
        {
        case  SDL_KEYUP:
            tecla = event.key.keysym.sym;
            //            printf("Evento Tecla UP  %d \n",tecla);
            if (tecla > 96 && tecla < 123) tecla -= 32;
            return (tecla);
            break;
        case  SDL_QUIT:
            return (27);
            break;
        }
    }
    return (0);
}


int waitQuit(void)
{
 int SimbolKey;
    while(0!=inkeyM()){}
    while(1)
    {
      SimbolKey=inkeyM();
      //printf("->%i\n",SimbolKey);
      if(SimbolKey==27) return(1);
      if(SimbolKey!=0) return(0);
    }
}
//__________________________________

void cls(int r,int g,int b)
{
    SDL_FillRect(screen, 0, SDL_MapRGB(screen->format,r,g,b));
    SDL_Flip(screen);
}


void printc(int x, int y, char* temp)
{
    static SDL_Surface *message;
    message = TTF_RenderText_Solid( font, temp, ColorDefault );
    apply_surface( x, y, message, screen );
    SDL_FreeSurface(message);
}

void printn(int x, int y, long temp)
{
    char VARI[20];
    sprintf(VARI, "%d", (int)temp);
    printc(x, y, VARI);
}

void impri(int x, int y, char c)
{
    char VARI[20];
    sprintf(VARI, "%c", c);
    printc(x, y, VARI);
}



/* -------------------------- LEE CADENA DEL TECLADO ----*/

char *inputc(int x, int y)
{

    int zz, n;
    static char VARI[20];

    setcolor(0, 100, 0);
    bar(x, y, x + 100, y + 20);
    setcolor(255, 255, 255);
    SDL_Flip( screen );
    for(zz=0; zz<10; zz++) inkeyM();

    n = 0;
    zz = 0;
    while (zz != 10)
    {
        zz = inkeyM();
        if (zz == 13 || zz == 27) goto fin;
        if (zz != 0)
        {
            setcolor(0, 100, 0);
            bar(x, y, x + 100, y + 20);
            setcolor(255, 255, 255);
            if (zz == 8)
            {
                n--;
                if (n < 0)n = 0;
                VARI[n] = 0;
            }
            else
            {
                VARI[n] = zz;
                VARI[n + 1] = 0;
                if (n < 6)n++;
            }
            printc(x, y, VARI);
            //        printf("%s\n",VARI);
            SDL_Flip( screen );
        }
    }
fin:
    VARI[n] = 0;
    return (VARI);
}

